#include "../os5-6.h"
#include <handleapi.h>
#include <processthreadsapi.h>
#include <synchapi.h>
#define EVENT
#ifndef EVENT
bool canwrite(true);
#endif

#define neediters 10000

using namespace std;

bool stopThreads(false);
float trapezoidal(float a, float b, unsigned int n) {
    float sum = 0;
    float h = (b - a) / n;
    sum += (f(a) + f(b)) / 2;
    for (int i = 1; i < n; i++) {
        while(stopThreads){}
        float x = a + i * h;
        sum += f(x);
    }
    return sum * h;
}

vector<unsigned int> t;
vector<HANDLE> threads;

unsigned short cthreads;
float result = 0.0;
HANDLE hEvent;

struct ThreadParams {
    float start;
    float end;
    float* result;
    unsigned int n;
};

DWORD WINAPI ThreadFunction(LPVOID lpParam) {
    ThreadParams* params = reinterpret_cast<ThreadParams*>(lpParam);
    float local_result = trapezoidal(params->start, params->end, params->n);

#ifdef EVENT
            WaitForSingleObject(hEvent, 0xFFFFFFFF);
#else
            while (!canwrite){}canwrite=false;
#endif
            result+=local_result;
#ifdef EVENT
            SetEvent(hEvent);
#else
            canwrite=true;
#endif
    return 0;
}

void displayMenu() {
    while (true) {
        cin.get();
        stopThreads = true;
        cout << cthreads << " threads were interrupted." << endl;
        display;
        char option;
        cin >> option;
        if (option == '1') {
            stopThreads = false;
            cin.get();
        } else if (option == '2') {
            cout << "Select thread to change priority: ";
            unsigned short thread;
            cin >> thread;
            cout << "Enter new priority: ";
            int priority;
            cin >> priority;
            if (SetThreadPriority(threads[thread - 1], priority) == 0) {
                cerr << "Setting priority failed" << endl;
            } else {
                cout << "Changed priority for thread " << threads[thread - 1] << endl;
            }
        } else if (option == '0') {
            displayinfo;
            exit(0);
        }
    }
}

int main() {
#ifdef EVENT
    HANDLE hEvent=CreateEvent(NULL,TRUE,TRUE,NULL);
#endif
    HANDLE hInput=CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)displayMenu, NULL, 0, NULL);

    for (cthreads = 1; cthreads <= num_threads; cthreads++) {
        float per = 100.0 / cthreads;
        float current = 0;
        result = 0.0;
        threads.clear();
        auto start = chrono::high_resolution_clock::now();

        for (unsigned char i = 0; i < cthreads; i++) {
            float start = current;
            current += per;
            unsigned int n=neediters/cthreads;
            ThreadParams* params = new ThreadParams{start, current, &result, n};

            HANDLE hThread = CreateThread(
                NULL, 0, ThreadFunction, params, 0, NULL);
            if (hThread) {
                threads.push_back(hThread);
            } else {
                cerr << "Failed to create thread " << i + 1 << endl;
                delete params;
            }
        }

        for (HANDLE hThread : threads) {
            WaitForSingleObject(hThread, 0xFFFFFFFF);
            CloseHandle(hThread);
        }

        t.push_back(chrono::duration_cast<chrono::nanoseconds>(chrono::high_resolution_clock::now() - start).count());
        //cout << result << endl;
    }

    TerminateThread(hInput, 0);
    displayinfo;

#ifdef EVENT
    CloseHandle(hEvent);
#endif
    return 0;
}
